﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static void Main()
		{
			CategoryBuilder.Create("Rooms & Furniture", "This category includes items from the Rooms & Furniture mod.", ModAPI.LoadSprite("Cubes.png"));
//Tags
			string Category = "Rooms & Furniture";
			string FurnitureName = "AFurniture";
			string RoomName = "AFurniture";		
			string Layer = "Default";
//Furnitures
		//Small Wooden Table
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Small Wooden Table",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Small Wooden Table.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 1f;
						PhysBeh.InitialMass = 1f;
						PhysBeh.rigidbody.mass = 1f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Small Wooden Table.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Small Wooden Table.png", 1f);

						var destructibleObjectBehaviour = Instance.GetOrAddComponent<DestructibleObjectBehaviour>();
                        destructibleObjectBehaviour.breakSounds = new AudioClip[] //Звуки при ломании объекта.
                        {
                            ModAPI.LoadSound("SFX/WoodBreak.wav")
                        };
                        destructibleObjectBehaviour.debrisCollisionSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Collisions/Small Wooden TableDebris1.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Small Wooden TableDebris2.png", 10f),
                            ModAPI.LoadSprite("Texture/Furniture/Collisions/Small Wooden TableDebris3.png", 10f)
                        };
                        destructibleObjectBehaviour.debrisSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Debris/Small Wooden TableDebris1.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Small Wooden TableDebris2.png"),
                            ModAPI.LoadSprite("Texture/Furniture/Debris/Small Wooden TableDebris3.png")
                        };
                        destructibleObjectBehaviour.debrisPositions = new Vector3[] //Расположение обломков.
                        {
                            new Vector3(0f, 0f),
							new Vector3(0f, 0f),
                            new Vector3(0f, 0f)
                        };
                        destructibleObjectBehaviour.debrisProperties = ModAPI.FindPhysicalProperties("Wood"); //Материал обломков.
                        destructibleObjectBehaviour.debrisMass = 0.005f; //Масса обломков.
                        destructibleObjectBehaviour.BreakingThreshold = 8f; //Сила ломания объекта.
                        destructibleObjectBehaviour.debrisNumber = 3; //Количество обломков.
					//End
					}
				}
			);
		//Big Wooden Table
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Big Wooden Table",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Big Bed Table.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 5f;
						PhysBeh.InitialMass = 5f;
						PhysBeh.rigidbody.mass = 5f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Big Bed Table.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Big Bed Table.png", 1f);

						var destructibleObjectBehaviour = Instance.GetOrAddComponent<DestructibleObjectBehaviour>();
                        destructibleObjectBehaviour.breakSounds = new AudioClip[] //Звуки при ломании объекта.
                        {
                            ModAPI.LoadSound("SFX/WoodBreak.wav")
                        };
                        destructibleObjectBehaviour.debrisCollisionSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Collisions/Big Bed TableDebris1.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Big Bed TableDebris2.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Big Bed TableDebris3.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Big Bed TableDebris4.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Big Bed TableDebris5.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Big Bed TableDebris6.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Big Bed TableDebris7.png", 10f)
                        };
                        destructibleObjectBehaviour.debrisSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Debris/Big Bed TableDebris1.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Big Bed TableDebris2.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Big Bed TableDebris3.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Big Bed TableDebris4.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Big Bed TableDebris5.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Big Bed TableDebris6.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Big Bed TableDebris7.png")
                        };
                        destructibleObjectBehaviour.debrisPositions = new Vector3[] //Расположение обломков.
                        {
                            new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f)
                        };
                        destructibleObjectBehaviour.debrisProperties = ModAPI.FindPhysicalProperties("Wood"); //Материал обломков.
                        destructibleObjectBehaviour.debrisMass = 0.005f; //Масса обломков.
                        destructibleObjectBehaviour.BreakingThreshold = 8f; //Сила ломания объекта.
                        destructibleObjectBehaviour.debrisNumber = 7; //Количество обломков.
					//End
					}
				}
			);
		//Wooden Stool
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Stool",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Stool.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 1f;
						PhysBeh.InitialMass = 1f;
						PhysBeh.rigidbody.mass = 1f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Stool.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Stool.png", 1f);

						var destructibleObjectBehaviour = Instance.GetOrAddComponent<DestructibleObjectBehaviour>();
                        destructibleObjectBehaviour.breakSounds = new AudioClip[] //Звуки при ломании объекта.
                        {
                            ModAPI.LoadSound("SFX/WoodBreak.wav")
                        };
                        destructibleObjectBehaviour.debrisCollisionSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden StoolDebris1.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden StoolDebris2.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden StoolDebris3.png", 10f)

                        };
                        destructibleObjectBehaviour.debrisSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden StoolDebris1.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden StoolDebris2.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden StoolDebris3.png")

                        };
                        destructibleObjectBehaviour.debrisPositions = new Vector3[] //Расположение обломков.
                        {
                            new Vector3(0f, 0f),
							new Vector3(0f, 0f),
                            new Vector3(0f, 0f)
                        };
                        destructibleObjectBehaviour.debrisProperties = ModAPI.FindPhysicalProperties("Wood"); //Материал обломков.
                        destructibleObjectBehaviour.debrisMass = 0.005f; //Масса обломков.
                        destructibleObjectBehaviour.BreakingThreshold = 8f; //Сила ломания объекта.
                        destructibleObjectBehaviour.debrisNumber = 3; //Количество обломков.
					//End
					}
				}
			);
		//Wooden Backless Сhair
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Backless Chair",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Backless Сhair.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 1f;
						PhysBeh.InitialMass = 1f;
						PhysBeh.rigidbody.mass = 1f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Backless Сhair.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Backless Сhair.png", 1f);

						var destructibleObjectBehaviour = Instance.GetOrAddComponent<DestructibleObjectBehaviour>();
                        destructibleObjectBehaviour.breakSounds = new AudioClip[] //Звуки при ломании объекта.
                        {
                            ModAPI.LoadSound("SFX/WoodBreak.wav")
                        };
                        destructibleObjectBehaviour.debrisCollisionSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Backless СhairDebris1.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Backless СhairDebris2.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Backless СhairDebris3.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Backless СhairDebris4.png", 10f)
                        };
                        destructibleObjectBehaviour.debrisSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Backless СhairDebris1.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Backless СhairDebris2.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Backless СhairDebris3.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Backless СhairDebris4.png")
                        };
                        destructibleObjectBehaviour.debrisPositions = new Vector3[] //Расположение обломков.
                        {
                            new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
                            new Vector3(0f, 0f)
                        };
                        destructibleObjectBehaviour.debrisProperties = ModAPI.FindPhysicalProperties("Wood"); //Материал обломков.
                        destructibleObjectBehaviour.debrisMass = 0.005f; //Масса обломков.
                        destructibleObjectBehaviour.BreakingThreshold = 8f; //Сила ломания объекта.
                        destructibleObjectBehaviour.debrisNumber = 4; //Количество обломков.
					//End
					}
				}
			);
		
		//Wooden Wall Shelf
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Wall Shelf",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Wall Shelf.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 1.2f;
						PhysBeh.InitialMass = 1.2f;
						PhysBeh.rigidbody.mass = 1.2f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Wall Shelf.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Wall Shelf.png", 1f);

						var destructibleObjectBehaviour = Instance.GetOrAddComponent<DestructibleObjectBehaviour>();
                        destructibleObjectBehaviour.breakSounds = new AudioClip[] //Звуки при ломании объекта.
                        {
                            ModAPI.LoadSound("SFX/WoodBreak.wav")
                        };
                        destructibleObjectBehaviour.debrisCollisionSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Wall Shelf1.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Wall Shelf2.png", 10f)
                        };
                        destructibleObjectBehaviour.debrisSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Wall Shelf1.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Wall Shelf2.png")
                        };
                        destructibleObjectBehaviour.debrisPositions = new Vector3[] //Расположение обломков.
                        {
                            new Vector3(0f, 0f),
							new Vector3(0f, 0f)
                        };
                        destructibleObjectBehaviour.debrisProperties = ModAPI.FindPhysicalProperties("Wood"); //Материал обломков.
                        destructibleObjectBehaviour.debrisMass = 0.005f; //Масса обломков.
                        destructibleObjectBehaviour.BreakingThreshold = 8f; //Сила ломания объекта.
                        destructibleObjectBehaviour.debrisNumber = 2; //Количество обломков.
					//End
					}
				}
			);
		//Wooden Bed Frame
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Bed Frame",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Bed.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 3f;
						PhysBeh.InitialMass = 3f;
						PhysBeh.rigidbody.mass = 3f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Bed.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Bed.png", 1f);

						var destructibleObjectBehaviour = Instance.GetOrAddComponent<DestructibleObjectBehaviour>();
                        destructibleObjectBehaviour.breakSounds = new AudioClip[] //Звуки при ломании объекта.
                        {
                            ModAPI.LoadSound("SFX/WoodBreak.wav")
                        };
                        destructibleObjectBehaviour.debrisCollisionSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Collisions/BedDebris1.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/BedDebris2.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/BedDebris3.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/BedDebris4.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/BedDebris5.png", 10f)
                        };
                        destructibleObjectBehaviour.debrisSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Debris/BedDebris1.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/BedDebris2.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/BedDebris3.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/BedDebris4.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/BedDebris5.png")
                        };
                        destructibleObjectBehaviour.debrisPositions = new Vector3[] //Расположение обломков.
                        {
                            new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
                            new Vector3(0f, 0f)
                        };
                        destructibleObjectBehaviour.debrisProperties = ModAPI.FindPhysicalProperties("Wood"); //Материал обломков.
                        destructibleObjectBehaviour.debrisMass = 0.005f; //Масса обломков.
                        destructibleObjectBehaviour.BreakingThreshold = 8f; //Сила ломания объекта.
                        destructibleObjectBehaviour.debrisNumber = 5; //Количество обломков.
					//End
					}
				}
			);
		
		
		//Wooden Closet With Shelves
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Closet With Shelves",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Closet With Shelves.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 4f;
						PhysBeh.InitialMass = 4f;
						PhysBeh.rigidbody.mass = 4f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Closet With Shelves.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Closet With Shelves.png", 1f);

						var destructibleObjectBehaviour = Instance.GetOrAddComponent<DestructibleObjectBehaviour>();
                        destructibleObjectBehaviour.breakSounds = new AudioClip[] //Звуки при ломании объекта.
                        {
                            ModAPI.LoadSound("SFX/WoodBreak.wav")
                        };
                        destructibleObjectBehaviour.debrisCollisionSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Closet With ShelvesDebris1.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Closet With ShelvesDebris2.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Closet With ShelvesDebris3.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Closet With ShelvesDebris4.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Closet With ShelvesDebris5.png", 10f),
							ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Closet With ShelvesDebris6.png", 10f)
                        };
                        destructibleObjectBehaviour.debrisSprites = new Sprite[] //Текстуры обломков.
                        {
                            ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Closet With ShelvesDebris1.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Closet With ShelvesDebris2.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Closet With ShelvesDebris3.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Closet With ShelvesDebris4.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Closet With ShelvesDebris5.png"),
							ModAPI.LoadSprite("Texture/Furniture/Debris/Wooden Closet With ShelvesDebris6.png")
                        };
                        destructibleObjectBehaviour.debrisPositions = new Vector3[] //Расположение обломков.
                        {
                            new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
							new Vector3(0f, 0f),
                            new Vector3(0f, 0f)
                        };
                        destructibleObjectBehaviour.debrisProperties = ModAPI.FindPhysicalProperties("Wood"); //Материал обломков.
                        destructibleObjectBehaviour.debrisMass = 0.005f; //Масса обломков.
                        destructibleObjectBehaviour.BreakingThreshold = 8f; //Сила ломания объекта.
                        destructibleObjectBehaviour.debrisNumber = 6; //Количество обломков.
					//End
					}
				}
			);
		
		//Wooden Cash Register Stand
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Cash Register Stand",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Cash Register Stand.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 5f;
						PhysBeh.InitialMass = 5f;
						PhysBeh.rigidbody.mass = 5f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Cash Register Stand.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Cash Register Stand.png", 1f);
					//End
					}
				}
			);
		//Wooden Bedside Table
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Bedside Table",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Bedside Table.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 2f;
						PhysBeh.InitialMass = 2f;
						PhysBeh.rigidbody.mass = 2f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Bedside Table.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Bedside Table.png", 1f);
					//End
					}
				}
			);
		
		
		//Small Crate
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Small Crate",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Small Crate.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 2f;
						PhysBeh.InitialMass = 2f;
						PhysBeh.rigidbody.mass = 2f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Small Crate.png", 1f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<PolygonCollider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						
					//End
					}
				}
			);
		//Wooden Brick
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Brick",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Brick.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 1.2f;
						PhysBeh.InitialMass = 1.2f;
						PhysBeh.rigidbody.mass = 1.2f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Brick.png", 1f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<PolygonCollider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						
					}
				}
			);
		//Wooden Door
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Door",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Door.png"),
					AfterSpawn = (Instance) =>
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Texture/Furniture/Wood Closed Door2.png", 1f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<PolygonCollider2D>(); 

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";

                        if(Instance.GetComponent<DoorBehaviour>() == null)
				    	{
				    	    Instance.AddComponent(typeof(DoorBehaviour));
				    	}
                        var Door = Instance.GetComponent<DoorBehaviour>();

                        Door.A = ModAPI.LoadSprite("Texture/Furniture/Wood Closed Door2.png", 1f);
                        Door.B = ModAPI.LoadSprite("Texture/Furniture/Wood Open Door2.png", 1f);

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.75f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.75f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.75f;
                        
                        AudioSource DoorAudio = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
                        Door.audioclipA = ModAPI.LoadSound("SFX/Wooden.mp3");
                        Door.audioclipB = ModAPI.LoadSound("SFX/Wooden2.mp3");
                        Door.audio = DoorAudio;
					}
				}
			);
		//Wooden Cube
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Cube",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Cube.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 1.2f;
						PhysBeh.InitialMass = 1.2f;
						PhysBeh.rigidbody.mass = 1.2f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Cube.png", 1f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<PolygonCollider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						
					}
				}
			);
		//Wooden patterned cube
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden patterned cube",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Cube2.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 1.2f;
						PhysBeh.InitialMass = 1.2f;
						PhysBeh.rigidbody.mass = 1.2f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Cube2.png", 1f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<PolygonCollider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						
					}
				}
			);
		//Wooden Stairs
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plank"),
					NameOverride = "Wooden Stairs",
					NameToOrderByOverride = FurnitureName,
					DescriptionOverride = " ",
					CategoryOverride = ModAPI.FindCategory(Category),
					ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Wooden Stairs.png"),
					AfterSpawn = (Instance) =>
					{
						PhysicalBehaviour PhysBeh = Instance.GetComponent<PhysicalBehaviour>();
						PhysBeh.Properties = ModAPI.FindPhysicalProperties("Wood");
						PhysBeh.TrueInitialMass = 1.2f;
						PhysBeh.InitialMass = 1.2f;
						PhysBeh.rigidbody.mass = 1.2f;

						SpriteRenderer SprRen = Instance.GetComponent<SpriteRenderer>();
						SprRen.sortingLayerName = "Bubbles";
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Collisions/Wooden Stairs.png", 10f);
							foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(ColliderBoxDeleteVar);
								}
							Instance.FixColliders();
						SprRen.sprite = ModAPI.LoadSprite("Texture/Furniture/Wooden Stairs.png", 1f);
					//End
					}
				}
			);
//Rooms
	//Wooden_Room_with_Door
		ModAPI.Register(
					new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Rod"),
						NameOverride = "Wooden Room with 1 Door",
						NameToOrderByOverride = RoomName,
						DescriptionOverride = " ",
						CategoryOverride = ModAPI.FindCategory(Category),
						ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Room.png"),
						AfterSpawn = (Instance) =>
						{
							var CustomCollision = Instance.AddComponent<CustomCollision>();
							CustomCollision.Sprite = ModAPI.LoadSprite("Texture/Rooms/Room.png", 1f);
							CustomCollision.CollisionSprite = ModAPI.LoadSprite("Texture/Rooms/Collision/Room.png", 5f);

							//New Objects
								/*GameObject Parent = new GameObject("Parent");

								GameObject door = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Pole").Prefab);    
								RoomDoorBehavior dbDoor = door.AddComponent<RoomDoorBehavior>();
								dbDoor.OpenS = ModAPI.LoadSprite("Texture/Rooms/Wood Open Door.png", 1f);
								dbDoor.CloseS =  ModAPI.LoadSprite("Texture/Rooms/Wood Closed Door.png", 1f);
								dbDoor.OpenClip = null;  //сюда звук 
								dbDoor.CloseClip = null; //сюда звук
								dbDoor.DoorPosition = new Vector3(-3.129f, -0.6f, 0f);
								dbDoor.PhysicalProperties = "Wood";                            
								dbDoor.CreateDoor(Instance, Parent);
								*/

							Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
							var phys = Instance.GetComponent<PhysicalBehaviour>();
							var prop = ModAPI.FindPhysicalProperties("Wood");
							phys.TrueInitialMass = 15f;
							phys.InitialMass = 15f;
							phys.rigidbody.mass = 15f;
						}
					}
				);
	//Wooden_Room_with_Doors
		ModAPI.Register(
					new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Rod"),
						NameOverride = "Wooden Room with 2 Doors",
						NameToOrderByOverride = RoomName,
						DescriptionOverride = " ",
						CategoryOverride = ModAPI.FindCategory(Category),
						ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Room2.png"),
						AfterSpawn = (Instance) =>
						{
							var CustomCollision = Instance.AddComponent<CustomCollision>();
							CustomCollision.Sprite = ModAPI.LoadSprite("Texture/Rooms/Room2.png", 1f);
							CustomCollision.CollisionSprite = ModAPI.LoadSprite("Texture/Rooms/Collision/Room2.png", 5f);

							//New Objects
								/*GameObject Parent = new GameObject("Parent");

								GameObject door = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Pole").Prefab);    
								RoomDoorBehavior dbDoor = door.AddComponent<RoomDoorBehavior>();
								dbDoor.OpenS = ModAPI.LoadSprite("Texture/Rooms/Wood Open Door.png", 1f);
								dbDoor.CloseS =  ModAPI.LoadSprite("Texture/Rooms/Wood Closed Door.png", 1f);
								dbDoor.OpenClip = null;  //сюда звук 
								dbDoor.CloseClip = null; //сюда звук
								dbDoor.DoorPosition = new Vector3(-3.129f, -0.6f, 0f);
								dbDoor.PhysicalProperties = "Wood";                            
								dbDoor.CreateDoor(Instance, Parent);

								GameObject door2 = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Pole").Prefab);    
								RoomDoorBehavior dbDoor2 = door2.AddComponent<RoomDoorBehavior>();
								dbDoor2.OpenS = ModAPI.LoadSprite("Texture/Rooms/Wood Open Door2.png", 1f);
								dbDoor2.CloseS =  ModAPI.LoadSprite("Texture/Rooms/Wood Closed Door2.png", 1f);
								dbDoor2.OpenClip = null;  //сюда звук 
								dbDoor2.CloseClip = null; //сюда звук 
								dbDoor2.DoorPosition = new Vector3(3.129f, -0.6f, 0f);
								dbDoor2.PhysicalProperties = "Wood";                            
								dbDoor2.CreateDoor(Instance, Parent);
		 */
							Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
							var phys = Instance.GetComponent<PhysicalBehaviour>();
							var prop = ModAPI.FindPhysicalProperties("Wood");
							phys.TrueInitialMass = 15f;
							phys.InitialMass = 15f;
							phys.rigidbody.mass = 15f;
						}
					}
				);
	//two-storey_house
		ModAPI.Register(
					new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Rod"),
						NameOverride = "Two-storey house",
						NameToOrderByOverride = RoomName,
						DescriptionOverride = " ",
						CategoryOverride = ModAPI.FindCategory(Category),
						ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Two-storey house.png"),
						AfterSpawn = (Instance) =>
						{
							var CustomCollision = Instance.AddComponent<CustomCollision>();
							CustomCollision.Sprite = ModAPI.LoadSprite("Texture/Rooms/Two-storey house.png", 1f);
							CustomCollision.CollisionSprite = ModAPI.LoadSprite("Texture/Rooms/Collision/Two-storey house.png", 5f);

							//New Objects
								/*GameObject Parent = new GameObject("Parent");

								GameObject door = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Pole").Prefab);    
								RoomDoorBehavior dbDoor = door.AddComponent<RoomDoorBehavior>();
								dbDoor.OpenS = ModAPI.LoadSprite("Texture/Rooms/Wood Open Door.png", 1f);
								dbDoor.CloseS =  ModAPI.LoadSprite("Texture/Rooms/Wood Closed Door.png", 1f);
								dbDoor.OpenClip = null;  //сюда звук 
								dbDoor.CloseClip = null; //сюда звук
								dbDoor.DoorPosition = new Vector3(-3.129f, -3.6449f, 0f);
								dbDoor.PhysicalProperties = "Wood";                            
								dbDoor.CreateDoor(Instance, Parent);
 		*/
							Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
							var phys = Instance.GetComponent<PhysicalBehaviour>();
							var prop = ModAPI.FindPhysicalProperties("Wood");
							phys.TrueInitialMass = 15f;
							phys.InitialMass = 15f;
							phys.rigidbody.mass = 15f;
						}
					}
				);
	//Gold Pole
		ModAPI.Register(
					new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Rod"),
						NameOverride = "Gold Pole",
						NameToOrderByOverride = "Metal Pole",
						DescriptionOverride = "3 meter tall gold pole.",
						CategoryOverride = ModAPI.FindCategory(Category),
						ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Gold.png"),
						AfterSpawn = (Instance) =>
						{
							Instance.GetComponent<SpriteRenderer>().sprite =  ModAPI.LoadSprite("Texture/Rooms/Gold.png", 1f);
							Instance.GetComponent<SpriteRenderer>().sortingLayerName = Layer;
							foreach (var c in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(c);
								}
							Instance.AddComponent<PolygonCollider2D>();        
							Instance.FixColliders();

							var phys = Instance.GetComponent<PhysicalBehaviour>();
							var prop = ModAPI.FindPhysicalProperties("Wood");
							phys.TrueInitialMass = 15f;
							phys.InitialMass = 15f;
							phys.rigidbody.mass = 15f;
						}
					}
				);
	//Copper Pole
		ModAPI.Register(
					new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Rod"),
						NameOverride = "Copper Pole",
						NameToOrderByOverride = "Metal Pole",
						DescriptionOverride = "5.15 meter tall copper pole.",
						CategoryOverride = ModAPI.FindCategory(Category),
						ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Copper.png"),
						AfterSpawn = (Instance) =>
						{
							Instance.GetComponent<SpriteRenderer>().sprite =  ModAPI.LoadSprite("Texture/Rooms/Copper.png", 1f);
							Instance.GetComponent<SpriteRenderer>().sortingLayerName = Layer;
							foreach (var c in Instance.GetComponents<Collider2D>())
								{
									GameObject.Destroy(c);
								}
							Instance.AddComponent<PolygonCollider2D>();        
							Instance.FixColliders();

							var phys = Instance.GetComponent<PhysicalBehaviour>();
							var prop = ModAPI.FindPhysicalProperties("Wood");
							phys.TrueInitialMass = 3f;
							phys.InitialMass = 3f;
							phys.rigidbody.mass = 3f;
						}
					}
				);
			}
		}
//Behavioures
	public class CustomCollision : MonoBehaviour
	{
		public SpriteRenderer SpriteRenderer;
		public Sprite Sprite;
		public Sprite CollisionSprite;
		
		private void Start()
		{         
			gameObject.GetComponent<SpriteRenderer>().sprite = CollisionSprite;

			foreach (var ColliderBoxDeleteVar in gameObject.GetComponents<Collider2D>())
			{
				GameObject.Destroy(ColliderBoxDeleteVar);
			}
			gameObject.FixColliders();

			gameObject.GetComponent<SpriteRenderer>().sprite = Sprite;

			gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
			gameObject.GetComponent<PhysicalBehaviour>().BakeColliderGridPoints();
		}
	}
	public class RoomDoorBehavior : MonoBehaviour
	{
		private bool Opened = false;   
		[SkipSerialisation]
		private SpriteRenderer renderer;
		[SkipSerialisation]
		private AudioSource AS;
		
		//Changeable variables
		[SkipSerialisation]
		public Sprite OpenS;
		[SkipSerialisation]
		public Sprite CloseS;
		
		[SkipSerialisation]
		public AudioClip OpenClip;
		[SkipSerialisation]
		public AudioClip CloseClip;
		
		[SkipSerialisation]
		public Vector3 DoorPosition = default(Vector3); //позиция двери относительбно комнаты ///x, y, 0
		[SkipSerialisation]
		public string PhysicalProperties = "Wood";
		[SkipSerialisation]
		//public bool FlipObject = false;

		public void CreateDoor(GameObject Instance, GameObject Parent)
		{  
			AS = gameObject.AddComponent<AudioSource>();

			PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();  
			phys.SendUserPropagation = false;
			phys.Properties = ModAPI.FindPhysicalProperties(PhysicalProperties);
			//phys.MainAudioSource.volume = 0.5f;

			renderer = gameObject.GetComponent<SpriteRenderer>();
			renderer.sprite = CloseS; 
			//renderer.flipY = FlipObject;       
			gameObject.FixColliders();
			
			//Attach    
			gameObject.transform.SetParent(Instance.transform);

			gameObject.transform.localEulerAngles = Vector3.zero;
			gameObject.transform.localPosition = DoorPosition;     
			gameObject.transform.localScale = Vector3.one;
			
			gameObject.transform.SetParent(Instance.transform);
			
			Instance.transform.SetParent(Parent.transform);
			gameObject.transform.SetParent(Parent.transform);

			FixedJoint2D fixedJoint2D = gameObject.AddComponent<FixedJoint2D>();
			fixedJoint2D.connectedBody = Instance.GetComponent<Rigidbody2D>();
			//fixedJoint2D.breakForce = 1000; //прочность соединения          
		}    
		private void Use()
		{
			Opened = !Opened;
			if(Opened)
			{
				renderer.sprite = OpenS;
				renderer.sortingLayerName = "Bottom";
				gameObject.layer = 10;
				AS.PlayOneShot(OpenClip);
			}
			else
			{
				renderer.sprite = CloseS;
				renderer.sortingLayerName = "Objects";
				gameObject.layer = LayerMask.NameToLayer("Objects");
				AS.PlayOneShot(CloseClip);
			}
		}
	}
	public class SpawnObjectBehavior : MonoBehaviour
	{
		//Changeable variables
		public Sprite sprite;
		public Sprite CollisionSprite;

		[SkipSerialisation]
		public Vector3 ObjectPosition = default(Vector3);//позиция относительбно комнаты ///x, y, 0

		public string PhysicalProperties = "Wood";
		public bool SetParent = true;
		public bool CreateJoint = true;
		//public bool FlipObject = false;

		public void CreateObject(GameObject Instance)
		{  
			PhysicalBehaviour phys = gameObject.GetComponent<PhysicalBehaviour>();            
			phys.Properties = ModAPI.FindPhysicalProperties(PhysicalProperties);

			gameObject.GetComponent<SpriteRenderer>().sprite = CollisionSprite;
			foreach (var ColliderBoxDeleteVar in gameObject.GetComponents<Collider2D>())
			{
				GameObject.Destroy(ColliderBoxDeleteVar);
			}
			gameObject.FixColliders();
			gameObject.GetComponent<SpriteRenderer>().sprite = sprite;
			//gameObject.GetComponent<SpriteRenderer>().flipY = FlipObject;
			
			//Attach
			if (SetParent)
			{
				gameObject.transform.SetParent(Instance.transform);    
			}                
			gameObject.transform.eulerAngles = new Vector3(0f, 0f, 0f); //0, 0,  угол
			gameObject.transform.position = Instance.transform.position + ObjectPosition; 
			gameObject.transform.localScale = Vector3.one;

			if (CreateJoint)
			{
				FixedJoint2D fixedJoint2D = gameObject.AddComponent<FixedJoint2D>();
				fixedJoint2D.connectedBody = Instance.GetComponent<Rigidbody2D>();
				//fixedJoint2D.breakForce = 1000; //прочность соединения
			}                
		}        
	}
	public class DestructibleObjectBehaviour : MonoBehaviour
    {
        private void OnCollisionStay2D(Collision2D collision)
        {
            EvaluateCollision(collision);
        }
        private void OnCollisionEnter2D(Collision2D collision)
        {
            EvaluateCollision(collision);
        }
        private void EvaluateCollision(Collision2D collision)
        {
            int contacts = collision.GetContacts(contactBuffer);
            float num = Utils.GetMinImpulse(contactBuffer, contacts);
            Vector2 point = contactBuffer[0].point;
            if(num < BreakingThreshold)
            {
                return;
            }
            Broken = true;
            Break();
        }
        private void Shot(Shot shot)
        {
            if(ShotDamage)
            {
                Break();
            }
        }
        private void OnFragmentHit()
        {
            Break();
        }
        private void Break()
        {
            GameObject audioObject = new GameObject("Audio Object");
            audioObject.transform.position = gameObject.transform.position;
            AudioSource audioSource = audioObject.AddComponent<AudioSource>();
            audioSource.spread = 0f;
            audioSource.volume = 0.8f;
            audioSource.minDistance = 10f;
            audioSource.spatialBlend = 1f;
            audioSource.dopplerLevel = 1f;
            audioSource.PlayOneShot(breakSounds.PickRandom(), 1f);
            audioObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            for(int i = 0; i < debrisNumber; i++)
            {
                debris = ModAPI.CreatePhysicalObject("Debris "+i.ToString(), debrisSprites[i]);
                debris.transform.localScale = gameObject.transform.localScale;
                debris.transform.position = gameObject.transform.position + debrisPositions[i];
                debris.GetComponent<Rigidbody2D>().velocity = gameObject.GetComponent<Rigidbody2D>().velocity + UnityEngine.Random.insideUnitCircle * 2f;
                debris.GetComponent<Rigidbody2D>().angularVelocity = gameObject.GetComponent<Rigidbody2D>().angularVelocity + UnityEngine.Random.Range(-200, 200);
                debris.GetOrAddComponent<DebrisComponent>();
                var debrisPhys = debris.GetComponent<PhysicalBehaviour>();
                debrisPhys.Properties = debrisProperties;
                debrisPhys.InitialMass = debrisMass;
                debrisPhys.rigidbody.mass = debrisMass;
                debrisPhys.TrueInitialMass = debrisPhys.InitialMass;
                var collision = debris.GetOrAddComponent<CustomCollision>();
                collision.SpriteRenderer = debris.GetComponent<SpriteRenderer>();
                collision.Sprite = debrisSprites[i];
                collision.CollisionSprite = debrisCollisionSprites[i];
				debris.layer = LayerMask.NameToLayer("Objects");
                //debris.layer = 10;
                debris.AddComponent<ActOnDestroy>().DestroyWith = new GameObject[]
                {
                    audioObject
                };
            }
            gameObject.SetActive(false);
        }

        public bool Broken = false;
        public bool ShotDamage = true;
        public GameObject debris;
        private ContactPoint2D[] contactBuffer = new ContactPoint2D[12];
        public AudioClip[] breakSounds;
        public Sprite[] debrisCollisionSprites;
        public Sprite[] debrisSprites;
        public Vector3[] debrisPositions;
        public PhysicalProperties debrisProperties;
        public float debrisMass;
        public float BreakingThreshold;
        public int debrisNumber;
    }
	class DoorBehaviour : MonoBehaviour
    {
       private void Start()
       {
           this.renderer = gameObject.GetComponent<SpriteRenderer>();
           UpdateState();
       }
       void UpdateState()
       {
           if(this.Activated)
           {
               renderer.sprite = B;
               renderer.sortingLayerName = "Background";
               gameObject.layer = 10;
               audio.PlayOneShot(audioclipB,1f);
           }
           else
           {
               renderer.sprite = A;
               renderer.sortingLayerName = "Objects";
               gameObject.layer = LayerMask.NameToLayer("Objects");
               audio.PlayOneShot(audioclipA,1f);
           }
       }
       private void Use() {
         if (!base.enabled) {
            return;
         }
         this.SetActivated(!this.Activated);
      }
      private void SetActivated(bool activated) {
         this.Activated = activated;
         UpdateState();
      }

      public bool Activated = false;
      [SkipSerialisation]
      public SpriteRenderer renderer;
      [SkipSerialisation]
      public Sprite A;
      [SkipSerialisation]
      public Sprite B;
      [SkipSerialisation]
      public AudioSource audio;
      [SkipSerialisation]
      public AudioClip audioclipA;
      [SkipSerialisation]
      public AudioClip audioclipB;
   }
}